package model

import korlibs.time.*
import kotlinx.serialization.Serializable

@Serializable
/** A [BattleEffect] represents some kind of timed impact on the game as a result of a [BattleAction]. */
sealed class BattleEffect: TimedEvent()

@Serializable
data class DamageEffect(override val timestamp: TimeSpan, val id: Battler.Id, val damage: Double): BattleEffect() {
    override fun Battle.EventAPI.execute() {
        battler(id) {
            inflictComposureDamage(damage)
        }
    }
}
