package model

import korlibs.time.*
import kotlinx.serialization.*

@Serializable
sealed class TimedEvent: Comparable<TimedEvent> {
    abstract val timestamp: TimeSpan
    abstract fun Battle.EventAPI.execute()

    override fun compareTo(other: TimedEvent): Int {
        return timestamp.compareTo(other.timestamp)
    }
}
